<template>
	<el-container>
		<el-header>
			<div class="left-panel">
				<el-button v-auth="'app:add'" type="primary" icon="el-icon-plus" @click="add"></el-button>
				<el-button v-auth="'app:del'" type="danger" plain icon="el-icon-delete" :disabled="selection.length===0" @click="batch_del"></el-button>
			</div>
			<div class="right-panel">
				<div class="right-panel-search">
					<el-input v-model="search.app_name" placeholder="应用名称" clearable style="width: 200px;"></el-input>
					<el-button type="primary" icon="el-icon-search" @click="upsearch"></el-button>
				</div>
			</div>
		</el-header>
		<el-main class="nopadding">
			<piTable ref="table" :apiObj="apiObj" @selection-change="selectionChange">
				<el-table-column type="selection" width="50"></el-table-column>
				<el-table-column label="应用ID" prop="app_id" width="100" align="center"></el-table-column>
				<el-table-column label="应用名称" prop="app_name" width="150" align="center"></el-table-column>
				<el-table-column label="APPCODE" prop="app_code" align="center"></el-table-column>
				<el-table-column label="APPKEY" prop="app_key" align="center"></el-table-column>
				<el-table-column label="状态" prop="status" align="center">
					<template #default="scope">
						<el-tag v-if="scope.row.status===1" type="success">启用</el-tag>
						<el-tag v-if="scope.row.status===0" type="danger">停用</el-tag>
					</template>
				</el-table-column>
				<el-table-column label="创建时间" prop="create_time" align="center"></el-table-column>
				<el-table-column label="操作" fixed="right" align="right" width="170">
					<template #default="scope">
						<el-button-group>
							<el-button text type="primary" size="small" @click="table_show(scope.row, scope.$index)">查看</el-button>
							<el-button v-auth="'app:edit'" text type="primary" size="small" @click="table_edit(scope.row, scope.$index)">编辑</el-button>
							<el-popconfirm title="确定删除吗？" @confirm="table_del(scope.row, scope.$index)">
								<template #reference>
									<el-button v-auth="'app:del'" text type="primary" size="small">删除</el-button>
								</template>
							</el-popconfirm>
						</el-button-group>
					</template>
				</el-table-column>
			</piTable>
		</el-main>
	</el-container>
	<save-dialog v-if="dialog.save" ref="saveDialog" @success="handleSaveSuccess" @closed="dialog.save=false"></save-dialog>
</template>

<script>
import saveDialog from './save'

export default {
	name: 'app',
	components: {
		saveDialog
	},
	data() {
		return {
			dialog: {
				save: false,
			},
			apiObj: this.$API.system.app.list,
			selection: [],
			search: {
				app_name: null
			}
		}
	},
	methods: {
		//添加
		add(){
			this.dialog.save = true
			this.$nextTick(() => {
				this.$refs.saveDialog.open()
			})
		},
		//编辑
		table_edit(row){
			this.dialog.save = true
			this.$nextTick(() => {
				this.$refs.saveDialog.open('edit').setData(row)
			})
		},
		//查看
		table_show(row){
			this.dialog.save = true
			this.$nextTick(() => {
				this.$refs.saveDialog.open('show').setData(row)
			})
		},
		//删除
		async table_del(row){
			const res = await this.$API.system.app.del({ids: row.app_id});
			this.$refs.table.refresh()
			this.$message.success(res.msg)
		},
		//批量删除
		async batch_del(){
			this.$confirm(`确定删除选中的 ${this.selection.length} 项吗？如果删除项中含有子集将会被一并删除`, '提示', {
				type: 'warning'
			}).then(async () => {
				const loading = this.$loading();
				const res = await this.$API.system.app.del({ids: this.selection.map(item => item.app_id).toString()});
				this.$refs.table.refresh()
				loading.close();
				this.$message.success(res.msg)
			})
		},
		//表格选择后回调事件
		selectionChange(selection){
			this.selection = selection;
		},
		//搜索
		upsearch(){
			this.$refs.table.upData(this.search)
		},
		//本地更新数据
		handleSaveSuccess(){
			this.$refs.table.refresh()
		}
	}
}
</script>

<style>
</style>
